﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace _507338
{
    public partial class Form1 : Form
    {
        Point clickedPoint;
        bool mouseDown = false;

        public Form1()
        {
            InitializeComponent();

            flowLayoutPanel1.BackColor = Color.Yellow;
            flowLayoutPanel1.AllowDrop = true;
            flowLayoutPanel1.DragEnter += new DragEventHandler(flowLayoutPanel1_DragEnter);
            flowLayoutPanel1.DragDrop += new DragEventHandler(flowLayoutPanel1_DragDrop);

            radTreeView1.MouseDown += new MouseEventHandler(radTreeView1_MouseDown);
            radTreeView1.MouseMove += new MouseEventHandler(radTreeView1_MouseMove);
            
        }

        
        void flowLayoutPanel1_DragDrop(object sender, DragEventArgs e)
        {
            RadTreeNode node = e.Data.GetData(typeof(RadTreeNode)) as RadTreeNode;
            if (node != null)
            {
                RadButton b = new RadButton();
                b.Text = node.Text;
                flowLayoutPanel1.Controls.Add(b);
            }
        }

        void flowLayoutPanel1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Copy;
        }

        void radTreeView1_MouseMove(object sender, MouseEventArgs e)
        {
            if (mouseDown && IsRealDrag(e.Location, clickedPoint))
            {
                TreeNodeElement node = ((RadTreeView)sender).ElementTree.GetElementAtPoint(clickedPoint) as TreeNodeElement;
                if (node != null)
                {
                    ((RadTreeView)sender).DoDragDrop(node.Data, DragDropEffects.Copy | DragDropEffects.Move);
                }
                mouseDown = false;
            }
        }

        void radTreeView1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                mouseDown = true;
                clickedPoint = e.Location;
            }
        }

        private static bool IsRealDrag(Point mousePosition, Point initialMousePosition)
        {
            return (Math.Abs(mousePosition.X - initialMousePosition.X) >= SystemInformation.DragSize.Width) ||
                (Math.Abs(mousePosition.Y - initialMousePosition.Y) >= SystemInformation.DragSize.Height);
        }
    }
}
